<img src="https://assets.terminusdb.com/images/horizontal_lockup_(2).png" width="350px"/>

## Build an ecosystem of versioned data products

[![CI](https://github.com/terminusdb/terminusdb/actions/workflows/ci.yml/badge.svg?event=push)](https://github.com/terminusdb/terminusdb/actions/workflows/ci.yml)
[![Docker](https://img.shields.io/docker/pulls/terminusdb/terminusdb-server?logo=Docker&style=plastic)](https://hub.docker.com/r/terminusdb/terminusdb-server)
[![Discord](https://img.shields.io/discord/689805612053168129?label=Discord&logo=Discord&style=plastic)](https://discord.gg/yTJKAma)
[![Discourse](https://img.shields.io/discourse/topics?color=yellow&logo=Discourse&server=https%3A%2F%2Fdiscuss.terminusdb.com%2F&style=plastic)](https://discuss.terminusdb.com/)

TerminusDB is an open source knowledge graph and document store. Use it to build versioned data products. 

TerminusX is a cloud self-service data platform built on TerminusDB. Use it to collaborate with colleagues to quickly build a vibrant ecosystem of domain data products. TerminusX is in **public beta** and you can [signup now](https://dashboard.terminusdb.com/).

TerminusDB provides a [document API](https://docs.terminusdb.com/v10.0/#/reference/reference-document-interface) for building via the JSON exchange format. The convenience of documents with the power of a knowledge graph.



<img src="https://assets.terminusdb.com/images/tdb-dashboard-tablet.png" width="100%" height="auto" />


TerminusDB allow you to build, deploy, execute, monitor, and share versioned data products. TerminusDB versions both data and schema allowing your team to deliver a consistent product to others while continuing to improve and innovate. Versioning is the enabler of collaboration and the future for all important data. TerminusDB brings software engineering best practices to data.

If you want to build: a knowledge graph of interconnected data products; data-intensive applications; or collaborate with colleagues, TerminusDB and TerminusX are right for you.


## Quick Links

| [Quick Start](https://docs.terminusdb.com/v10.0/#/terminusx/quick-start-overview)     | [Bootstrap TerminusDB](https://github.com/terminusdb/terminusdb-bootstrap)       | [TerminusX Beta Docs](https://docs.terminusdb.com/#/)       |  [TerminusDB 10.0 Dev Docs](https://docs.terminusdb.com/next/#/)         | [Python Client](https://github.com/terminusdb/terminusdb-client-python)         | [JavaScript Client](https://github.com/terminusdb/terminusdb-client-js) | 
| :--- | :--- | :--- | :--- | :--- | :--- |

<br/><br/>

<img src="https://assets.terminusdb.com/images/terminusdb-github-intro.gif" width="100%" height="auto" />

<br/>

TerminusDB is a lightweight, high-speed immutable database. Our [delta-encoding](docs/whitepaper/terminusdb.pdf) approach makes branch, merge, push, pull, clone, time-travel, and other git-like operations possible.

**Data collaboration is facilitated through [TerminusX](https://signup.terminusdb.com)**, which is a cloud self-service data platform enabling you to build, deploy, execute, monitor, and share versioned data products.


## Why TerminusDB/TerminusX

* Get started in minutes. Work using your preferred language, or use our low-code console to get your database running in just a few minutes.
* Add, replace and query documents using our document interface.
* Powerful query allows you to search for repeating patterns using recursion.
* Generate forms, get data validation, and a flexible & surfable document interface (in the console).
* Visual tool to build complex data models, which are easy, maintainable, and enforced.
* Data science/data engineering functionality directly in the database and via TerminusX.
* Versioning as a first class citizen. Commit graphs and data lineage out of the box. 
* Clone the production database and associated schema to branch, merge, collaborate, and time travel.
* New paradigm in data-centric, domain focused, and decentralized data product development.


## Community

Come visit us [Discord](https://discord.gg/yTJKAma)
or our [forum](https://discuss.terminusdb.com). We are also on [twitter](https://twitter.com/TerminusDB)
<img align="right" src="https://assets.terminusdb.com/images/TerminusDB%20color%20mascot.png" width="256px"/>

## Changes in this Version

[Release Notes](docs/RELEASE_NOTES.md)

## Copyright

Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at
```
http://www.apache.org/licenses/LICENSE-2.0
```

<!DOCTYPE html>
<html>
   <head>
   </head>
   <body>
      <a href="https://signup.terminusdb.com/">
         <img alt="TerminusX" src="https://github.com/terminusdb/terminusdb-web-assets/blob/master/images/sign-up-now-button.png"
         width="150" height="auto">
      </a>
   </body>
</html>
